/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006      by Monami Software Limited Partnership, JAPAN
 *  Copyright (C) 2007-2008	by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *	åȥƥ¸⥸塼 ֥OAKS32Rѡ
 */

#define	TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */

#include "kernel_impl.h"
#include "m32r_gcc/m32rasm.inc"

/*
 *	֥å쥯ȥȥ
 *
 *  ꡼ɻեȥȿ1
 *	åե꡼ɻեȥȿ0
 *  Х16ӥå
 *	饤Ȼեȥȿ1
 *  BSELȡʤ
 *  ȥֽϥߥӥåȡBSEL1BCLK
 *  ڡ̵
 *  READYԤʤ
 *  ꥫХꥵ롧
 *  ȿ0
 */
#define BSEL1CR_VAL	0x0fffb50f
		
/*
 *	SDRAMޥ
 */

/* 
 *  SDRAM쥸0
 *
 *  ץ㡼륦(DPC): 1
 *  ȥեå(DARFC): 8
 *  ȥեåֳ(DARFI): 5BCLK
 */
#define	SDIR0_VAL	0x00000182	

/* 
 *  SDRAM쥸1
 *
 *  ơǤϤʤ
 *  󥹳ϡ
 */
#define SDIR1_VAL	0x00000001
		
/*
 *  SDRAM0⡼ɥ쥸
 *  
 *  ⡼ɥ쥸0x20
 *  Сȥ⡼(WB) : 0
 *  CAS : 1 
 *  Сȥס󥷥 BT : 0
 *  СĹ : 0
 */
#define SD0MOD_VAL	0x00000010

/* 
 *  SDRAM0ߥ󥰥쥸
 *  
 *  ƥִ֡3
 *  졼ƥ󥷡1
 *  ץ㡼֡1
 *  饤ȥꥫХ֡2
 *  SDRAMȥ饫졼ƥ󥷡2
 */
//#define SD0TR_VAL	0x00000100
#define SD0TR_VAL	0x00000300

/* 
 *  SDRAM0ɥ쥹쥸
 *  
 *  Ƭɥ쥹ӥåȡ001000(A3-A8) BSEL1
 *  Х32ӥå
 *  ͥ륵8M
 */
#define	SD0ADR_VAL	0x01000041

/*
 *  SDBR
 */
#define	SDBR_VAL	0x00000001
		
/*
 *  SDRAMեå쥸1׽
 *
 *  ȥեå塧ͭ
 *  ȥեå奵롧2
 *  ȥեå׵ֳ֡384
 *  ȥեå(DRFEN):1(ͭ
 *  ȥեå奦(DREFW): 3BCLK/4BCLK
 *  ȥեå׵ֳ(DRFC): 384 BCLK
 */
#define SDRF1_VAL	0x00010117

/*
 *  SDRAM0֥͡쥸
 *  
 *  SDRAMͭӥåȡͭ
 */
#define SD0ER_VAL	0x00000001		

	.text
//	.globl hardware_init_hook
hardware_init_hook:
		
	/* PLLåư */
	ld24	r0, PLLCR+3
	ldi 	r1, #0x1
	st		r1, @r0
		
	/* PIO */
	ld24	r0, PMOD(0)
	ldi		r1, #0x0140			// BSEL1#ͭ
	sth		r1, @r0

	ld24	r0, PMOD(1)
	ldi		r1, #0x0001			// RD/WR#ͭ 
	sth		r1, @r0

	ld24	r0, PMOD(2)
	ldi		r1, #0x0001			// WS3#ͭ
	sth		r1, @r0

	ld24	r0, PMOD(3)
	ldi		r1, 0x5555			// D16-23ͭ
	sth		r1, @r0

	ld24	r0, PMOD(4)
	ldi		r1, 0x5555			// D24-31ͭ 
	sth		r1, @r0

	ld24	r0, PMOD(5)
	ldi		r1, 0x5050		// TxD0,1 RxD0,1ͭ
	sth		r1, @r0

	ld24	r0, PMOD(6)
	ldi		r1, 0x0515		// SDRAMüͭ P64ͭ
	sth		r1, @r0

	ld24	r0, PMOD(7)
	ldi		r1, 0x0040		// INT4ͭ
	sth		r1, @r0
		
	/* BSEL1 */
	ld24	r0, BSELCR(1)
	lea		r1, #BSEL1CR_VAL
	st		r1, @r0
		
	/* SDRAM */
	ld24	r0, SDIR0+2
	ldi		r1, 0x182
	sth		r1, @r0
		
	/* SDRAM󥹳 */
	ld24	r0, SDIR1+3
	ldi		r1, 1
	stb		r1, @r0
	addi	r0, -2
wait_sdram:
	ldb		r1, @r0
	bnez	r1, wait_sdram		/* DINSTӥåȤꥢȽλ */
		
	/* SDRAM⡼ɥ쥸 */
	ld24	r2, SDMOD(0)		
	lea		r3, SD0MOD_VAL	
	st		r3, @r2

	/* SDRAMΰ(H'010000008MХ,32bitBUS)	*/
	ld24	r2, SDADR(0)
	lea		r3, SD0ADR_VAL	
	st		r3, @r2

	/* SDRAMߥ󥰥쥸 */
	ld24	r2, SDTR(0)
	lea		r3, SD0TR_VAL
	st      r3, @r2	

	ld24	r2, SDBR+3
	ldi		r3, #0x2
	stb		r3, @r2
		
	/* ȥեåͭ׵ֳ:1344å */
	ld24	r2, #SDRF1
	lea		r3, SDRF1_VAL	
	st		r3, @r2

	/* SDRAM֥͡쥸	*/
	ld24	r2, SDER(0)
	lea		r3, SD0ER_VAL
	st		r3, @r2

	/* ݡP7(LED0,1 JP1,JP2³) */
	ld24	r2, PDATA(7)
	ldi		r3, #0x3f
    stb		r3, @r2				// b0    :P70 = 0 (LED0 ON 
        						// b1    :P71 = 0 (LED1 ON)
		
	ld24	r2, PDIR(7)
	ldi		r3, #0xc7
	stb		r3, @r2				// b0-1  :1 (P70,P71 out) 
        						// b2-b4 :0 (P72-P74 in) 
        						// b5-b7 :1 (P75-P77 out) 
		
	ld24	r2, CPUCLKCR
	lea		r3, 0x00020100		/* CPUåȤPLLå */
	st		r3, @r2

	/* ݡϵ */
	ld24	r2, PIEN
	ldi		r3, #0x01			// ϥݡON
	stb		r3, @r2

	jmp		r14
